diff -ruNp linux-2.6.34.5/kernel/itimer.c linux-2.6.34.5-cher1/kernel/itimer.c
--- linux-2.6.34.5/kernel/itimer.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/itimer.c	2010-08-26 14:45:12.364562651 +0400
@@ -105,6 +105,9 @@ SYSCALL_DEFINE2(getitimer, int, which, s
 	int error = -EFAULT;
 	struct itimerval get_buffer;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (value) {
 		error = do_getitimer(which, &get_buffer);
 		if (!error &&
@@ -282,6 +285,9 @@ SYSCALL_DEFINE3(setitimer, int, which, s
 	struct itimerval set_buffer, get_buffer;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (value) {
 		if(copy_from_user(&set_buffer, value, sizeof(set_buffer)))
 			return -EFAULT;
diff -ruNp linux-2.6.34.5/kernel/kexec.c linux-2.6.34.5-cher1/kernel/kexec.c
--- linux-2.6.34.5/kernel/kexec.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/kexec.c	2010-08-26 14:45:12.365567402 +0400
@@ -942,6 +942,11 @@ SYSCALL_DEFINE4(kexec_load, unsigned lon
 	struct kimage **dest_image, *image;
 	int result;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -1033,6 +1038,11 @@ asmlinkage long compat_sys_kexec_load(un
 	struct kexec_segment out, __user *ksegments;
 	unsigned long i, result;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Don't allow clients that don't understand the native
 	 * architecture to do anything.
 	 */
diff -ruNp linux-2.6.34.5/kernel/module.c linux-2.6.34.5-cher1/kernel/module.c
--- linux-2.6.34.5/kernel/module.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/module.c	2010-08-26 14:45:12.366567334 +0400
@@ -716,6 +716,11 @@ SYSCALL_DEFINE2(delete_module, const cha
 	char name[MODULE_NAME_LEN];
 	int ret, forced = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_MODULE) || modules_disabled)
 		return -EPERM;
 
@@ -2505,6 +2510,11 @@ SYSCALL_DEFINE3(init_module, void __user
 	struct module *mod;
 	int ret = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Must have permission */
 	if (!capable(CAP_SYS_MODULE) || modules_disabled)
 		return -EPERM;
diff -ruNp linux-2.6.34.5/kernel/perf_event.c linux-2.6.34.5-cher1/kernel/perf_event.c
--- linux-2.6.34.5/kernel/perf_event.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/perf_event.c	2010-08-26 14:45:12.375557153 +0400
@@ -4848,6 +4848,9 @@ SYSCALL_DEFINE5(perf_event_open,
 	int fput_needed = 0;
 	int err;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* for future expandability... */
 	if (flags & ~(PERF_FLAG_FD_NO_GROUP | PERF_FLAG_FD_OUTPUT))
 		return -EINVAL;
diff -ruNp linux-2.6.34.5/kernel/posix-cpu-timers.c linux-2.6.34.5-cher1/kernel/posix-cpu-timers.c
--- linux-2.6.34.5/kernel/posix-cpu-timers.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/posix-cpu-timers.c	2010-08-26 14:45:12.481672366 +0400
@@ -26,6 +26,19 @@ void update_rlimit_cpu(unsigned long rli
 	}
 }
 
+void update_rlimit_mcpu(unsigned long rlim_new)
+{
+	cputime_t cputime = msecs_to_cputime(rlim_new);
+	struct signal_struct *const sig = current->signal;
+
+	if (cputime_eq(sig->it[CPUCLOCK_PROF].expires, cputime_zero) ||
+	    cputime_gt(sig->it[CPUCLOCK_PROF].expires, cputime)) {
+		spin_lock_irq(&current->sighand->siglock);
+		set_process_cpu_timer(current, CPUCLOCK_PROF, &cputime, NULL);
+		spin_unlock_irq(&current->sighand->siglock);
+	}
+}
+
 static int check_clock(const clockid_t which_clock)
 {
 	int error = 0;
@@ -643,6 +656,10 @@ static void arm_timer(struct k_itimer *t
 				if (i != RLIM_INFINITY &&
 				    i <= cputime_to_secs(exp->cpu))
 					break;
+				i = sig->rlim[RLIMIT_MCPU].rlim_cur;
+				if (i != RLIM_INFINITY &&
+				    i <= cputime_to_msecs(exp->cpu))
+					break;
 				sig->cputime_expires.prof_exp = exp->cpu;
 				break;
 			case CPUCLOCK_SCHED:
@@ -1134,6 +1151,7 @@ static void check_process_timers(struct 
 	if (list_empty(&timers[CPUCLOCK_PROF]) &&
 	    cputime_eq(sig->it[CPUCLOCK_PROF].expires, cputime_zero) &&
 	    sig->rlim[RLIMIT_CPU].rlim_cur == RLIM_INFINITY &&
+	    sig->rlim[RLIMIT_MCPU].rlim_cur == RLIM_INFINITY &&
 	    list_empty(&timers[CPUCLOCK_VIRT]) &&
 	    cputime_eq(sig->it[CPUCLOCK_VIRT].expires, cputime_zero) &&
 	    list_empty(&timers[CPUCLOCK_SCHED])) {
@@ -1210,6 +1228,8 @@ static void check_process_timers(struct 
 			 * At the hard limit, we just die.
 			 * No need to calculate anything else now.
 			 */
+			if ((tsk->sbox_flags & SBOX_TLON))
+				tsk->sbox_flags |= SBOX_WAS_TL;
 			__group_send_sig_info(SIGKILL, SEND_SIG_PRIV, tsk);
 			return;
 		}
@@ -1230,6 +1250,39 @@ static void check_process_timers(struct 
 		}
 	}
 
+	soft = ACCESS_ONCE(sig->rlim[RLIMIT_MCPU].rlim_cur);
+	if (soft != RLIM_INFINITY) {
+		unsigned long pmsecs = cputime_to_msecs(ptime);
+		unsigned long hard =
+			ACCESS_ONCE(sig->rlim[RLIMIT_MCPU].rlim_max);
+		cputime_t x;
+		if (pmsecs >= hard) {
+			/*
+			 * At the hard limit, we just die.
+			 * No need to calculate anything else now.
+			 */
+			if ((tsk->sbox_flags & SBOX_TLON))
+				tsk->sbox_flags |= SBOX_WAS_TL;
+			__group_send_sig_info(SIGKILL, SEND_SIG_PRIV, tsk);
+			return;
+		}
+		if (pmsecs >= soft) {
+			/*
+			 * At the soft limit, send a SIGXCPU every second.
+			 */
+			__group_send_sig_info(SIGXCPU, SEND_SIG_PRIV, tsk);
+			if (soft < hard) {
+				soft++;
+				sig->rlim[RLIMIT_MCPU].rlim_cur = soft;
+			}
+		}
+		x = msecs_to_cputime(soft);
+		if (cputime_eq(prof_expires, cputime_zero) ||
+		    cputime_lt(x, prof_expires)) {
+			prof_expires = x;
+		}
+	}
+
 	if (!cputime_eq(prof_expires, cputime_zero) &&
 	    (cputime_eq(sig->cputime_expires.prof_exp, cputime_zero) ||
 	     cputime_gt(sig->cputime_expires.prof_exp, prof_expires)))
@@ -1390,7 +1443,8 @@ static inline int fastpath_timer_check(s
 			return 1;
 	}
 
-	return sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY;
+	return sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY
+           || sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY;
 }
 
 /*
@@ -1491,6 +1545,9 @@ void set_process_cpu_timer(struct task_s
 		if (tsk->signal->rlim[RLIMIT_CPU].rlim_cur
 		    < cputime_to_secs(*newval))
 			return;
+		if (tsk->signal->rlim[RLIMIT_MCPU].rlim_cur
+                    < cputime_to_msecs(*newval))
+			return;
 	}
 
 	/*
diff -ruNp linux-2.6.34.5/kernel/posix-timers.c linux-2.6.34.5-cher1/kernel/posix-timers.c
--- linux-2.6.34.5/kernel/posix-timers.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/posix-timers.c	2010-08-26 14:45:12.481672366 +0400
@@ -528,6 +528,11 @@ SYSCALL_DEFINE3(timer_create, const cloc
 	sigevent_t event;
 	int it_id_set = IT_ID_NOT_SET;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -706,6 +711,11 @@ SYSCALL_DEFINE2(timer_gettime, timer_t, 
 	struct itimerspec cur_setting;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -735,6 +745,11 @@ SYSCALL_DEFINE1(timer_getoverrun, timer_
 	int overrun;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -807,6 +822,11 @@ SYSCALL_DEFINE4(timer_settime, timer_t, 
 	unsigned long flag;
 	struct itimerspec *rtn = old_setting ? &old_spec : NULL;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!new_setting)
 		return -EINVAL;
 
@@ -857,6 +877,11 @@ SYSCALL_DEFINE1(timer_delete, timer_t, t
 	struct k_itimer *timer;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 retry_delete:
 	timer = lock_timer(timer_id, &flags);
 	if (!timer)
@@ -943,6 +968,11 @@ SYSCALL_DEFINE2(clock_settime, const clo
 {
 	struct timespec new_tp;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
@@ -957,6 +987,11 @@ SYSCALL_DEFINE2(clock_gettime, const clo
 	struct timespec kernel_tp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	error = CLOCK_DISPATCH(which_clock, clock_get,
@@ -974,6 +1009,11 @@ SYSCALL_DEFINE2(clock_getres, const cloc
 	struct timespec rtn_tp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1004,6 +1044,11 @@ SYSCALL_DEFINE4(clock_nanosleep, const c
 {
 	struct timespec t;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
diff -ruNp linux-2.6.34.5/kernel/printk.c linux-2.6.34.5-cher1/kernel/printk.c
--- linux-2.6.34.5/kernel/printk.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/printk.c	2010-08-26 14:45:12.596558501 +0400
@@ -410,6 +410,9 @@ out:
 
 SYSCALL_DEFINE3(syslog, int, type, char __user *, buf, int, len)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_syslog(type, buf, len, SYSLOG_FROM_CALL);
 }
 
diff -ruNp linux-2.6.34.5/kernel/ptrace.c linux-2.6.34.5-cher1/kernel/ptrace.c
--- linux-2.6.34.5/kernel/ptrace.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/ptrace.c	2010-08-26 14:45:12.629563879 +0400
@@ -666,6 +666,24 @@ SYSCALL_DEFINE4(ptrace, long, request, l
 	struct task_struct *child;
 	long ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
+	if (request == PTRACE_MEMLIMIT) {
+		current->sbox_flags |= SBOX_MEMLIMITON;
+		return 0;
+	}
+	if (request == PTRACE_NO_SYSCALLS) {
+		current->sbox_flags |= SBOX_NO_SYSCALLS;
+		return 0;
+	}
+	if (request == PTRACE_TIMELIMIT) {
+		current->sbox_flags |= SBOX_TLON;
+		return 0;
+	}
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
@@ -813,6 +831,20 @@ asmlinkage long compat_sys_ptrace(compat
 	struct task_struct *child;
 	long ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
+	if (request == PTRACE_MEMLIMIT) {
+		current->sbox_flags |= SBOX_MEMLIMITON;
+		return 0;
+	}
+	if (request == PTRACE_NO_SYSCALLS) {
+		current->sbox_flags |= SBOX_NO_SYSCALLS;
+		return 0;
+	}
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
diff -ruNp linux-2.6.34.5/kernel/sched.c linux-2.6.34.5-cher1/kernel/sched.c
--- linux-2.6.34.5/kernel/sched.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/sched.c	2010-08-26 14:45:12.633682990 +0400
@@ -4384,6 +4384,11 @@ SYSCALL_DEFINE1(nice, int, increment)
 {
 	long nice, retval;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/*
 	 * Setpriority might change our priority at the same moment.
 	 * We don't have to worry. Conceptually one call occurs first
@@ -4697,6 +4702,11 @@ do_sched_setscheduler(pid_t pid, int pol
 SYSCALL_DEFINE3(sched_setscheduler, pid_t, pid, int, policy,
 		struct sched_param __user *, param)
 {
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* negative values for policy are not valid */
 	if (policy < 0)
 		return -EINVAL;
@@ -4711,6 +4721,11 @@ SYSCALL_DEFINE3(sched_setscheduler, pid_
  */
 SYSCALL_DEFINE2(sched_setparam, pid_t, pid, struct sched_param __user *, param)
 {
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	return do_sched_setscheduler(pid, -1, param);
 }
 
@@ -4864,6 +4879,11 @@ SYSCALL_DEFINE3(sched_setaffinity, pid_t
 	cpumask_var_t new_mask;
 	int retval;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!alloc_cpumask_var(&new_mask, GFP_KERNEL))
 		return -ENOMEM;
 
diff -ruNp linux-2.6.34.5/kernel/signal.c linux-2.6.34.5-cher1/kernel/signal.c
--- linux-2.6.34.5/kernel/signal.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/signal.c	2010-08-26 14:45:12.646562077 +0400
@@ -1245,6 +1245,14 @@ static int kill_something_info(int sig, 
 {
 	int ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		if (!pid) pid = current->pid;
+		if (pid != current->pid) {
+			SBOX_SET_SECURITY_ERR();
+			return -EPERM;
+		}
+	}
+
 	if (pid > 0) {
 		rcu_read_lock();
 		ret = kill_pid_info(sig, info, find_vpid(pid));
@@ -2110,6 +2118,9 @@ SYSCALL_DEFINE4(rt_sigprocmask, int, how
 	int error = -EINVAL;
 	sigset_t old_set, new_set;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2166,6 +2177,9 @@ out:
 
 SYSCALL_DEFINE2(rt_sigpending, sigset_t __user *, set, size_t, sigsetsize)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_sigpending(set, sigsetsize);
 }
 
@@ -2245,6 +2259,9 @@ SYSCALL_DEFINE4(rt_sigtimedwait, const s
 	siginfo_t info;
 	long timeout = 0;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2378,6 +2395,9 @@ static int do_tkill(pid_t tgid, pid_t pi
  */
 SYSCALL_DEFINE3(tgkill, pid_t, tgid, pid_t, pid, int, sig)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0 || tgid <= 0)
 		return -EINVAL;
@@ -2390,6 +2410,9 @@ SYSCALL_DEFINE3(tgkill, pid_t, tgid, pid
  */
 SYSCALL_DEFINE2(tkill, pid_t, pid, int, sig)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0)
 		return -EINVAL;
@@ -2402,6 +2425,9 @@ SYSCALL_DEFINE3(rt_sigqueueinfo, pid_t, 
 {
 	siginfo_t info;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
 		return -EFAULT;
 
@@ -2435,6 +2461,9 @@ SYSCALL_DEFINE4(rt_tgsigqueueinfo, pid_t
 {
 	siginfo_t info;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
 		return -EFAULT;
 
@@ -2557,6 +2586,9 @@ out:
 
 SYSCALL_DEFINE1(sigpending, old_sigset_t __user *, set)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_sigpending(set, sizeof(*set));
 }
 
@@ -2572,6 +2604,9 @@ SYSCALL_DEFINE3(sigprocmask, int, how, o
 	int error;
 	old_sigset_t old_set, new_set;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (set) {
 		error = -EFAULT;
 		if (copy_from_user(&new_set, set, sizeof(*set)))
@@ -2625,6 +2660,11 @@ SYSCALL_DEFINE4(rt_sigaction, int, sig,
 	struct k_sigaction new_sa, old_sa;
 	int ret = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED()) {
+		if (sig == SIGINT || sig == SIGTERM)
+			return -EPERM;
+        }
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2660,6 +2700,9 @@ SYSCALL_DEFINE1(ssetmask, int, newmask)
 {
 	int old;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	spin_lock_irq(&current->sighand->siglock);
 	old = current->blocked.sig[0];
 
@@ -2681,6 +2724,9 @@ SYSCALL_DEFINE2(signal, int, sig, __sigh
 	struct k_sigaction new_sa, old_sa;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	new_sa.sa.sa_handler = handler;
 	new_sa.sa.sa_flags = SA_ONESHOT | SA_NOMASK;
 	sigemptyset(&new_sa.sa.sa_mask);
@@ -2695,6 +2741,9 @@ SYSCALL_DEFINE2(signal, int, sig, __sigh
 
 SYSCALL_DEFINE0(pause)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	current->state = TASK_INTERRUPTIBLE;
 	schedule();
 	return -ERESTARTNOHAND;
@@ -2707,6 +2756,9 @@ SYSCALL_DEFINE2(rt_sigsuspend, sigset_t 
 {
 	sigset_t newset;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
diff -ruNp linux-2.6.34.5/kernel/sys.c linux-2.6.34.5-cher1/kernel/sys.c
--- linux-2.6.34.5/kernel/sys.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/sys.c	2010-08-26 14:45:12.661557144 +0400
@@ -154,6 +154,11 @@ SYSCALL_DEFINE3(setpriority, int, which,
 	int error = -EINVAL;
 	struct pid *pgrp;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		goto out;
 
@@ -371,6 +376,11 @@ SYSCALL_DEFINE4(reboot, int, magic1, int
 	char buffer[256];
 	int ret = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -487,6 +497,11 @@ SYSCALL_DEFINE2(setregid, gid_t, rgid, g
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -538,6 +553,11 @@ SYSCALL_DEFINE1(setgid, gid_t, gid)
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -605,6 +625,11 @@ SYSCALL_DEFINE2(setreuid, uid_t, ruid, u
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -670,6 +695,11 @@ SYSCALL_DEFINE1(setuid, uid_t, uid)
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -715,6 +745,11 @@ SYSCALL_DEFINE3(setresuid, uid_t, ruid, 
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -783,6 +818,11 @@ SYSCALL_DEFINE3(setresgid, gid_t, rgid, 
 	struct cred *new;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -845,6 +885,11 @@ SYSCALL_DEFINE1(setfsuid, uid_t, uid)
 	struct cred *new;
 	uid_t old_fsuid;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return current_fsuid();
@@ -882,6 +927,11 @@ SYSCALL_DEFINE1(setfsgid, gid_t, gid)
 	struct cred *new;
 	gid_t old_fsgid;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	new = prepare_creds();
 	if (!new)
 		return current_fsgid();
@@ -926,6 +976,11 @@ void do_sys_times(struct tms *tms)
 
 SYSCALL_DEFINE1(times, struct tms __user *, tbuf)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (tbuf) {
 		struct tms tmp;
 
@@ -956,6 +1011,11 @@ SYSCALL_DEFINE2(setpgid, pid_t, pid, pid
 	struct pid *pgrp;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!pid)
 		pid = task_pid_vnr(group_leader);
 	if (!pgid)
@@ -1090,6 +1150,11 @@ SYSCALL_DEFINE0(setsid)
 	pid_t session = pid_vnr(sid);
 	int err = -EPERM;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	write_lock_irq(&tasklist_lock);
 	/* Fail if I am already a session leader */
 	if (group_leader->signal->leader)
@@ -1198,6 +1263,11 @@ SYSCALL_DEFINE2(sethostname, char __user
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1247,6 +1317,11 @@ SYSCALL_DEFINE2(setdomainname, char __us
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1308,6 +1383,11 @@ SYSCALL_DEFINE2(setrlimit, unsigned int,
 	struct rlimit new_rlim, *old_rlim;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (resource >= RLIM_NLIMITS)
 		return -EINVAL;
 	if (copy_from_user(&new_rlim, rlim, sizeof(*rlim)))
@@ -1334,11 +1414,25 @@ SYSCALL_DEFINE2(setrlimit, unsigned int,
 		 */
 		new_rlim.rlim_cur = 1;
 	}
+	if (resource == RLIMIT_MCPU && new_rlim.rlim_cur == 0) {
+		/*
+		 * The caller is asking for an immediate RLIMIT_MCPU
+		 * expiry.  But we use the zero value to mean "it was
+		 * never set".  So let's cheat and make it one msec
+		 * instead
+		 */
+		new_rlim.rlim_cur = 1;
+	}
 
 	task_lock(current->group_leader);
 	*old_rlim = new_rlim;
 	task_unlock(current->group_leader);
 
+        if (resource == RLIMIT_MCPU && new_rlim.rlim_cur != RLIM_INFINITY) {
+		update_rlimit_mcpu(new_rlim.rlim_cur);
+		return 0;
+	}
+
 	if (resource != RLIMIT_CPU)
 		goto out;
 
@@ -1490,6 +1584,10 @@ SYSCALL_DEFINE2(getrusage, int, who, str
 
 SYSCALL_DEFINE1(umask, int, mask)
 {
+	if (SBOX_IS_RESTRICTED()) {
+		return current->fs->umask;
+	}
+
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
 	return mask;
 }
@@ -1501,6 +1599,11 @@ SYSCALL_DEFINE5(prctl, int, option, unsi
 	unsigned char comm[sizeof(me->comm)];
 	long error;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	error = security_task_prctl(option, arg2, arg3, arg4, arg5);
 	if (error != -ENOSYS)
 		return error;
diff -ruNp linux-2.6.34.5/kernel/sysctl_binary.c linux-2.6.34.5-cher1/kernel/sysctl_binary.c
--- linux-2.6.34.5/kernel/sysctl_binary.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/sysctl_binary.c	2010-08-26 14:45:12.666698163 +0400
@@ -1469,6 +1469,9 @@ SYSCALL_DEFINE1(sysctl, struct __sysctl_
 	size_t oldlen = 0;
 	ssize_t result;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
 
@@ -1513,6 +1516,9 @@ asmlinkage long compat_sys_sysctl(struct
 	size_t oldlen = 0;
 	ssize_t result;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
 
diff -ruNp linux-2.6.34.5/kernel/time.c linux-2.6.34.5-cher1/kernel/time.c
--- linux-2.6.34.5/kernel/time.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/time.c	2010-08-26 14:45:12.667567421 +0400
@@ -83,6 +83,11 @@ SYSCALL_DEFINE1(stime, time_t __user *, 
 	struct timespec tv;
 	int err;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -190,6 +195,11 @@ SYSCALL_DEFINE2(settimeofday, struct tim
 	struct timespec	new_ts;
 	struct timezone new_tz;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (tv) {
 		if (copy_from_user(&user_tv, tv, sizeof(*tv)))
 			return -EFAULT;
@@ -209,6 +219,11 @@ SYSCALL_DEFINE1(adjtimex, struct timex _
 	struct timex txc;		/* Local copy of parameter */
 	int ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* Copy the user data space into the kernel copy
 	 * structure. But bear in mind that the structures
 	 * may change
diff -ruNp linux-2.6.34.5/kernel/timer.c linux-2.6.34.5-cher1/kernel/timer.c
--- linux-2.6.34.5/kernel/timer.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/timer.c	2010-08-26 14:45:12.668557296 +0400
@@ -1249,6 +1249,10 @@ void do_timer(unsigned long ticks)
  */
 SYSCALL_DEFINE1(alarm, unsigned int, seconds)
 {
+	if (SBOX_IS_RESTRICTED()) {
+		return -EPERM;
+	}
+
 	return alarm_setitimer(seconds);
 }
 
diff -ruNp linux-2.6.34.5/kernel/uid16.c linux-2.6.34.5-cher1/kernel/uid16.c
--- linux-2.6.34.5/kernel/uid16.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/kernel/uid16.c	2010-08-26 14:45:12.668557296 +0400
@@ -189,6 +189,11 @@ SYSCALL_DEFINE2(setgroups16, int, gidset
 	struct group_info *group_info;
 	int retval;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
diff -ruNp linux-2.6.34.5/Makefile linux-2.6.34.5-cher1/Makefile
--- linux-2.6.34.5/Makefile	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/Makefile	2010-08-26 14:48:55.497693577 +0400
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 6
 SUBLEVEL = 34
-EXTRAVERSION = .5
+EXTRAVERSION = .5-cher1
 NAME = Sheep on Meth
 
 # *DOCUMENTATION*
diff -ruNp linux-2.6.34.5/mm/fadvise.c linux-2.6.34.5-cher1/mm/fadvise.c
--- linux-2.6.34.5/mm/fadvise.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/fadvise.c	2010-08-26 14:45:12.670562467 +0400
@@ -26,7 +26,7 @@
  */
 SYSCALL_DEFINE(fadvise64_64)(int fd, loff_t offset, loff_t len, int advice)
 {
-	struct file *file = fget(fd);
+	struct file *file;
 	struct address_space *mapping;
 	struct backing_dev_info *bdi;
 	loff_t endbyte;			/* inclusive */
@@ -35,6 +35,12 @@ SYSCALL_DEFINE(fadvise64_64)(int fd, lof
 	unsigned long nrpages;
 	int ret = 0;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
+        file = fget(fd);
 	if (!file)
 		return -EBADF;
 
diff -ruNp linux-2.6.34.5/mm/filemap.c linux-2.6.34.5-cher1/mm/filemap.c
--- linux-2.6.34.5/mm/filemap.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/filemap.c	2010-08-26 14:45:12.671572525 +0400
@@ -1344,6 +1344,9 @@ SYSCALL_DEFINE(readahead)(int fd, loff_t
 	ssize_t ret;
 	struct file *file;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	ret = -EBADF;
 	file = fget(fd);
 	if (file) {
diff -ruNp linux-2.6.34.5/mm/fremap.c linux-2.6.34.5-cher1/mm/fremap.c
--- linux-2.6.34.5/mm/fremap.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/fremap.c	2010-08-26 14:45:12.683617803 +0400
@@ -130,6 +130,9 @@ SYSCALL_DEFINE5(remap_file_pages, unsign
 	int err = -EINVAL;
 	int has_write_lock = 0;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (prot)
 		return err;
 	/*
diff -ruNp linux-2.6.34.5/mm/madvise.c linux-2.6.34.5-cher1/mm/madvise.c
--- linux-2.6.34.5/mm/madvise.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/madvise.c	2010-08-26 14:45:12.684568496 +0400
@@ -341,6 +341,9 @@ SYSCALL_DEFINE3(madvise, unsigned long, 
 	int write;
 	size_t len;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 #ifdef CONFIG_MEMORY_FAILURE
 	if (behavior == MADV_HWPOISON || behavior == MADV_SOFT_OFFLINE)
 		return madvise_hwpoison(behavior, start, start+len_in);
diff -ruNp linux-2.6.34.5/mm/mempolicy.c linux-2.6.34.5-cher1/mm/mempolicy.c
--- linux-2.6.34.5/mm/mempolicy.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mempolicy.c	2010-08-26 14:45:12.685578975 +0400
@@ -1168,6 +1168,9 @@ SYSCALL_DEFINE6(mbind, unsigned long, st
 	int err;
 	unsigned short mode_flags;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	mode_flags = mode & MPOL_MODE_FLAGS;
 	mode &= ~MPOL_MODE_FLAGS;
 	if (mode >= MPOL_MAX)
@@ -1189,6 +1192,9 @@ SYSCALL_DEFINE3(set_mempolicy, int, mode
 	nodemask_t nodes;
 	unsigned short flags;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	flags = mode & MPOL_MODE_FLAGS;
 	mode &= ~MPOL_MODE_FLAGS;
 	if ((unsigned int)mode >= MPOL_MAX)
@@ -1213,6 +1219,9 @@ SYSCALL_DEFINE4(migrate_pages, pid_t, pi
 	nodemask_t task_nodes;
 	int err;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	err = get_nodes(&old, old_nodes, maxnode);
 	if (err)
 		return err;
@@ -1339,6 +1348,9 @@ asmlinkage long compat_sys_set_mempolicy
 	unsigned long nr_bits, alloc_size;
 	DECLARE_BITMAP(bm, MAX_NUMNODES);
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	nr_bits = min_t(unsigned long, maxnode-1, MAX_NUMNODES);
 	alloc_size = ALIGN(nr_bits, BITS_PER_LONG) / 8;
 
@@ -1363,6 +1375,9 @@ asmlinkage long compat_sys_mbind(compat_
 	unsigned long nr_bits, alloc_size;
 	nodemask_t bm;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	nr_bits = min_t(unsigned long, maxnode-1, MAX_NUMNODES);
 	alloc_size = ALIGN(nr_bits, BITS_PER_LONG) / 8;
 
diff -ruNp linux-2.6.34.5/mm/migrate.c linux-2.6.34.5-cher1/mm/migrate.c
--- linux-2.6.34.5/mm/migrate.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/migrate.c	2010-08-26 14:45:12.696557342 +0400
@@ -1036,6 +1036,11 @@ SYSCALL_DEFINE6(move_pages, pid_t, pid, 
 	struct mm_struct *mm;
 	int err;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* Check flags */
 	if (flags & ~(MPOL_MF_MOVE|MPOL_MF_MOVE_ALL))
 		return -EINVAL;
diff -ruNp linux-2.6.34.5/mm/mincore.c linux-2.6.34.5-cher1/mm/mincore.c
--- linux-2.6.34.5/mm/mincore.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mincore.c	2010-08-26 14:45:12.696557342 +0400
@@ -221,6 +221,11 @@ SYSCALL_DEFINE3(mincore, unsigned long, 
 	unsigned long pages;
 	unsigned char *tmp;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* Check the start address: needs to be page-aligned.. */
  	if (start & ~PAGE_CACHE_MASK)
 		return -EINVAL;
diff -ruNp linux-2.6.34.5/mm/mlock.c linux-2.6.34.5-cher1/mm/mlock.c
--- linux-2.6.34.5/mm/mlock.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mlock.c	2010-08-26 14:45:12.697572569 +0400
@@ -483,6 +483,11 @@ SYSCALL_DEFINE2(mlock, unsigned long, st
 	unsigned long lock_limit;
 	int error = -ENOMEM;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!can_do_mlock())
 		return -EPERM;
 
@@ -509,6 +514,11 @@ SYSCALL_DEFINE2(munlock, unsigned long, 
 {
 	int ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	down_write(&current->mm->mmap_sem);
 	len = PAGE_ALIGN(len + (start & ~PAGE_MASK));
 	start &= PAGE_MASK;
@@ -547,6 +557,11 @@ SYSCALL_DEFINE1(mlockall, int, flags)
 	unsigned long lock_limit;
 	int ret = -EINVAL;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!flags || (flags & ~(MCL_CURRENT | MCL_FUTURE)))
 		goto out;
 
@@ -574,6 +589,11 @@ SYSCALL_DEFINE0(munlockall)
 {
 	int ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	down_write(&current->mm->mmap_sem);
 	ret = do_mlockall(0);
 	up_write(&current->mm->mmap_sem);
